/**
 * 
 */
package com.walletkit.sdk;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.walletkit.sdk.resources.Location;
import com.walletkit.sdk.utils.WKUtils;

/**
 * WalletKit pass details for pass creation
 * 
 * @author WalletKit <support@walletkit.com>
 * @version 1.0
 */
public class WKPassData {

	private Map<String, String> keyValuePairs = new HashMap<String, String>();
	private List<Location> locations;
	private String barcodeMessage;
	private String barcodeAlternateText;
	private String emailAddress;
	private String emailSubject;
	private String emailBody;
	private String sendTo;
	private String icon;
	private String background;
	private String logo;
	private String thumbnail;
	private String strip;
	private String icon2x;
	private String background2x;
	private String logo2x;
	private String thumbnail2x;
	private String strip2x;
	private String templateId;

	/**
	 * @return the keyValuePairs
	 */
	public Map<String, String> getKeyValuePairs() {
		return keyValuePairs;
	}

	/**
	 * @param keyValuePairs
	 *            the keyValuePairs to set
	 */
	public void setKeyValuePairs(final Map<String, String> keyValuePairs) {
		this.keyValuePairs = keyValuePairs;
	}

	/**
	 * @return the location
	 */
	public List<Location> getLocationList() {
		return locations;
	}

	/**
	 * @param location
	 *            the location to set
	 */
	public void setLocationList(final List<Location> location) {
		this.locations = location;
	}

	/**
	 * @return the barcodeMessage
	 */
	public String getBarcodeMessage() {
		return barcodeMessage;
	}

	/**
	 * @param barcodeMessage
	 *            the barcodeMessage to set
	 */
	public void setBarcodeMessage(final String barcodeMessage) {
		this.barcodeMessage = barcodeMessage;
	}

	/**
	 * @return the barcodeAlternateText
	 */
	public String getBarcodeAlternateText() {
		return barcodeAlternateText;
	}

	/**
	 * @param barcodeAlternateText
	 *            the barcodeAlternateText to set
	 */
	public void setBarcodeAlternateText(final String barcodeAlternateText) {
		this.barcodeAlternateText = barcodeAlternateText;
	}

	/**
	 * @return the emailAddress
	 */
	public String getSenderEmailAddress() {
		return emailAddress;
	}

	/**
	 * @param emailAddress
	 *            the emailAddress to set
	 */
	public void setSenderEmailAddress(final String emailAddress) {
		this.emailAddress = emailAddress;
	}

	/**
	 * @return the emailSubject
	 */
	public String getEmailSubject() {
		return emailSubject;
	}

	/**
	 * @param emailSubject
	 *            the emailSubject to set
	 */
	public void setEmailSubject(final String emailSubject) {
		this.emailSubject = emailSubject;
	}

	/**
	 * @return the emailBody
	 */
	public String getEmailBody() {
		return emailBody;
	}

	/**
	 * @param emailBody
	 *            the emailBody to set
	 */
	public void setEmailBody(final String emailBody) {
		this.emailBody = emailBody;
	}

	/**
	 * @return the sendTo
	 */
	public String getReceiverEmailAddress() {
		return sendTo;
	}

	/**
	 * @param sendTo
	 *            the sendTo to set
	 */
	public void setReceiverEmailAddress(final String sendTo) {
		this.sendTo = sendTo;
	}

	/**
	 * @return the icon
	 */
	public String getIcon() {
		return icon;
	}

	/**
	 * @param icon
	 *            the icon to set
	 */
	public void setIcon(final String icon) {
		this.icon = icon;
	}

	/**
	 * @return the background
	 */
	public String getBackground() {
		return background;
	}

	/**
	 * @param background
	 *            the background to set
	 */
	public void setBackground(final String background) {
		this.background = background;
	}

	/**
	 * @return the logo
	 */
	public String getLogo() {
		return logo;
	}

	/**
	 * @param logo
	 *            the logo to set
	 */
	public void setLogo(final String logo) {
		this.logo = logo;
	}

	/**
	 * @return the thumbnail
	 */
	public String getThumbnail() {
		return thumbnail;
	}

	/**
	 * @param thumbnail
	 *            the thumbnail to set
	 */
	public void setThumbnail(final String thumbnail) {
		this.thumbnail = thumbnail;
	}

	/**
	 * @return the strip
	 */
	public String getStrip() {
		return strip;
	}

	/**
	 * @param strip
	 *            the strip to set
	 */
	public void setStrip(final String strip) {
		this.strip = strip;
	}

	/**
	 * @return the icon2x
	 */
	public String getIcon2x() {
		return icon2x;
	}

	/**
	 * @param icon2x
	 *            the icon2x to set
	 */
	public void setIcon2x(final String icon2x) {
		this.icon2x = icon2x;
	}

	/**
	 * @return the background2x
	 */
	public String getBackground2x() {
		return background2x;
	}

	/**
	 * @param background2x
	 *            the background2x to set
	 */
	public void setBackground2x(final String background2x) {
		this.background2x = background2x;
	}

	/**
	 * @return the logo2x
	 */
	public String getLogo2x() {
		return logo2x;
	}

	/**
	 * @param logo2x
	 *            the logo2x to set
	 */
	public void setLogo2x(final String logo2x) {
		this.logo2x = logo2x;
	}

	/**
	 * @return the thumbnail2x
	 */
	public String getThumbnail2x() {
		return thumbnail2x;
	}

	/**
	 * @param thumbnail2x
	 *            the thumbnail2x to set
	 */
	public void setThumbnail2x(final String thumbnail2x) {
		this.thumbnail2x = thumbnail2x;
	}

	/**
	 * @return the strip2x
	 */
	public String getStrip2x() {
		return strip2x;
	}

	/**
	 * @param strip2x
	 *            the strip2x to set
	 */
	public void setStrip2x(final String strip2x) {
		this.strip2x = strip2x;
	}

	/**
	 * @return the templateId
	 */
	public String getTemplateId() {
		return templateId;
	}

	/**
	 * @param templateId
	 *            the templateId to set
	 */
	public void setTemplateId(final String templateId) {
		this.templateId = templateId;
	}

	private JSONArray getLocationJSON() {
		JSONArray locationList = null;
		if (locations != null && locations.size() > 0) {
			locationList = new JSONArray();
			for (int i = 0; i < locations.size(); i++) {
				final JSONObject job = new JSONObject();
				final String latitude = locations.get(i).getLatitude();
				final String longitude = locations.get(i).getLongitude();
				final String altitude = locations.get(i).getAltitude();
				final String relevantText = locations.get(i).getRelevantText();
				try {
					if (WKUtils.isParamSet(latitude) == true)
						job.put("latitude", latitude);
					if (WKUtils.isParamSet(longitude) == true)
						job.put("longitude", longitude);
					if (WKUtils.isParamSet(altitude) == true)
						job.put("altitude", altitude);
					if (WKUtils.isParamSet(relevantText) == true)
						job.put("relevanttext", relevantText);
				} catch (JSONException e) {
					e.printStackTrace();
				}
				locationList.put(job);
			}
		}
		return locationList;
	}

	public String getJson() {
		final JSONObject jobj = new JSONObject();
		try {
			jobj.put("keys", WKUtils.getJson(keyValuePairs));
			jobj.put("location", getLocationJSON());
			jobj.put("barcode_message", barcodeMessage);
			jobj.put("barcode_alttext", barcodeAlternateText);
			jobj.put("email", emailAddress);
			jobj.put("emailsubject", emailSubject);
			jobj.put("emailbody", emailBody);
			jobj.put("emailname", sendTo);
			jobj.put("icon", icon);
			jobj.put("background", background);
			jobj.put("logo", logo);
			jobj.put("thumbnail", thumbnail);
			jobj.put("strip", strip);
			jobj.put("icon2x", icon2x);
			jobj.put("background2x", background2x);
			jobj.put("logo2x", logo2x);
			jobj.put("thumbnail2x", thumbnail2x);
			jobj.put("strip2x", strip2x);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jobj.toString();
	}
}
