package com.walletkit.sdk.resources;

import java.util.List;

/**
 * WalletKit Pass Structure
 * 
 * @author WalletKit <support@walletkit.com>
 * @version 1.0
 */
public class Pass {

	protected String description;
	protected String passType;
	protected String transitType;
	protected String icon;
	protected String background;
	protected String logo;
	protected String thumbnail;
	protected String strip;
	protected String icon2x;
	protected String background2x;
	protected String logo2x;
	protected String thumbnail2x;
	protected String strip2x;
	protected String logoText;
	protected String username;
	protected String relevantDate;
	protected String foregroundColor;
	protected String backgroundColor;
	protected String labelColor;
	protected BarCode barcode;
	protected List<Location> locations;
	protected List<HeaderField> headerFields;
	protected List<PrimaryField> primaryFields;
	protected List<SecondaryField> secondaryFields;
	protected List<AuxiliaryField> auxiliaryFields;
	protected List<BackField> backFields;
	protected boolean isRetinaOptimized;

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getPassType() {
		return passType;
	}

	public void setPassType(String passType) {
		this.passType = passType;
	}

	public String getTransitType() {
		return transitType;
	}

	public void setTransitType(String transitType) {
		this.transitType = transitType;
	}

	public String getIcon() {
		return icon;
	}

	public void setIcon(String icon) {
		this.icon = icon;
	}

	public String getBackground() {
		return background;
	}

	public void setBackground(String background) {
		this.background = background;
	}

	public String getLogo() {
		return logo;
	}

	public void setLogo(String logo) {
		this.logo = logo;
	}

	public String getThumbnail() {
		return thumbnail;
	}

	public void setThumbnail(String thumbnail) {
		this.thumbnail = thumbnail;
	}

	public String getStrip() {
		return strip;
	}

	public void setStrip(String strip) {
		this.strip = strip;
	}

	public String getIcon2x() {
		return icon2x;
	}

	public void setIcon2x(String icon2x) {
		isRetinaOptimized = true;
		this.icon2x = icon2x;
	}

	public String getBackground2x() {
		return background2x;
	}

	public void setBackground2x(String background2x) {
		this.background2x = background2x;
		isRetinaOptimized = true;
	}

	public String getLogo2x() {
		return logo2x;
	}

	public void setLogo2x(String logo2x) {
		this.logo2x = logo2x;
		isRetinaOptimized = true;
	}

	public String getThumbnail2x() {
		return thumbnail2x;
	}

	public void setThumbnail2x(String thumbnail2x) {
		this.thumbnail2x = thumbnail2x;
		isRetinaOptimized = true;
	}

	public String getStrip2x() {
		return strip2x;
	}

	public void setStrip2x(String strip2x) {
		this.strip2x = strip2x;
		isRetinaOptimized = true;
	}

	public String getLogoText() {
		return logoText;
	}

	public void setLogoText(String logoText) {
		this.logoText = logoText;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getRelevantDate() {
		return relevantDate;
	}

	public void setRelevantDate(String relevantDate) {
		this.relevantDate = relevantDate;
	}

	public String getForegroundColor() {
		return foregroundColor;
	}

	public void setForegroundColor(String foregroundColor) {
		this.foregroundColor = foregroundColor;
	}

	public String getBackgroundColor() {
		return backgroundColor;
	}

	public void setBackgroundColor(String backgroundColor) {
		this.backgroundColor = backgroundColor;
	}

	public String getLabelColor() {
		return labelColor;
	}

	public void setLabelColor(String labelColor) {
		this.labelColor = labelColor;
	}

	public BarCode getBarcode() {
		return barcode;
	}

	public void setBarcode(BarCode barcode) {
		this.barcode = barcode;
	}

	public List<Location> getLocationList() {
		return locations;
	}

	public void setLocation(List<Location> location) {
		this.locations = location;
	}

	public List<HeaderField> getHeaderFieldList() {
		return headerFields;
	}

	public void setHeaderFieldList(List<HeaderField> headerFields) {
		this.headerFields = headerFields;
	}

	public List<PrimaryField> getPrimaryFieldList() {
		return primaryFields;
	}

	public void setPrimaryFieldList(List<PrimaryField> primaryFields) {
		this.primaryFields = primaryFields;
	}

	public List<SecondaryField> getSecondaryFields() {
		return secondaryFields;
	}

	public void setSecondaryFieldList(List<SecondaryField> secondaryFields) {
		this.secondaryFields = secondaryFields;
	}

	public List<AuxiliaryField> getAuxiliaryFields() {
		return auxiliaryFields;
	}

	public void setAuxiliaryFieldList(List<AuxiliaryField> auxiliaryFields) {
		this.auxiliaryFields = auxiliaryFields;
	}

	public List<BackField> getBackFields() {
		return backFields;
	}

	public void setBackFieldList(List<BackField> backFields) {
		this.backFields = backFields;
	}

}
